const OrderModel = require("../model/OrderModel");

//CRUD Operations
const newOrder = (req, res) => {
  let Order = new OrderModel(req.body);
  Order.save()
    .then(() => res.send("Order Added"))
    .catch((err) =>
      res.status(400).send("Error in add Order controller\nError is\n" + err)
    );
};
const getAllOrders = async (req, res) => {
  const Orders = await OrderModel.find({});
  res.json(Orders);
};

const getOrderById = (req, res) => {
  OrderModel.findOne({ _id: req.params.id })
    .then((response) => {
      res.json(response);
    })
    .catch((err) => console.log(err));
};
const updateOrder = (req, res) => {
  OrderModel.findOneAndUpdate({ _id: req.params.id }, req.body, {
    new: true,
  })
    .then((response) => res.json(response))
    .catch((err) => res.json(err));
};
const deleteOrder = (req, res) => {
  console.log("delete order");
  OrderModel.findOneAndDelete({ _id: req.params.id })
    .then((response) => {
      console.log(response);
      res.json({ message: response });
    })
    .catch((err) => res.json({ message: err }));
};

module.exports = {
  getAllOrders,
  getOrderById,
  newOrder,
  updateOrder,
  deleteOrder,
};
